using Exferia_Aplicacion.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System.Runtime.CompilerServices;
using Exferia_General;
using Exferia_Mythos._0_Modelos;
using System.Transactions;
using System.Data.SqlClient;
using System.Threading;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_Mythos._1_Datos
{
    public class MYT_Infraestructuras_Datos : ABS_Datos
    {

        #region Listado
        private List<INTERNO_MYT_Infraestructuras_Listado_Modelo> g_lst_INTERNO_MYT_Infraestructuras_Listado_Modelo = null;


        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            List<dynamic> lst_MYT = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(MYT_Infraestructuras).Name), _lst_CamposConRelacionABuscar, -1, null, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_MYT_Infraestructuras_Listado_Modelo != null) && (g_lst_INTERNO_MYT_Infraestructuras_Listado_Modelo.Count() > 0))
                {
                    lst_MYT = g_lst_INTERNO_MYT_Infraestructuras_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Infraestructuras_Datos) + "/" + nameof(Obtener_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_MYT;
        }

        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_MYT = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta..................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(MYT_Infraestructuras).Name), _lst_CamposConRelacionABuscar, _lng_id, _lst_ids, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                //..........................................................

                if ((g_lst_INTERNO_MYT_Infraestructuras_Listado_Modelo != null) && (g_lst_INTERNO_MYT_Infraestructuras_Listado_Modelo.Count() > 0))
                {
                    dnm_MYT = g_lst_INTERNO_MYT_Infraestructuras_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Infraestructuras_Datos) + "/" + nameof(Obtener_RegistroListado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_MYT;
        }

        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                string str_SQL =
                   " SELECT " +
                       nameof(INTERNO_MYT_Infraestructuras_Listado_Modelo.id) + " = " + nameof(MYT_Infraestructuras) + "." + nameof(MYT_Infraestructuras.id) + "," +
                       nameof(INTERNO_MYT_Infraestructuras_Listado_Modelo.codigo) + " = " + nameof(MYT_Infraestructuras) + "." + nameof(MYT_Infraestructuras.codigo) + "," +
                       nameof(INTERNO_MYT_Infraestructuras_Listado_Modelo.descripcion) + " = " + nameof(MYT_Infraestructuras) + "." + nameof(MYT_Infraestructuras.descripcion) + 
               " FROM " + nameof(MYT_Infraestructuras) +
               " WHERE " + nameof(MYT_Infraestructuras) + "." + nameof(MYT_Infraestructuras.fechaBorrado) + " IS null AND " +
                       (_lng_id > -1 ? ( nameof(MYT_Infraestructuras) + "." + nameof(MYT_Infraestructuras.id) + " = @id") : "1 = 1");

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_lst_INTERNO_MYT_Infraestructuras_Listado_Modelo = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_MYT_Infraestructuras_Listado_Modelo>(str_SQL, arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Infraestructuras_Datos) + "/" + nameof(ConsultaRellenar_Listado), true);
            }
        }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }

        #endregion
        #region F3
        private INTERNO_MYT_Infraestructuras_Listado_Modelo g_mdl_INTERNO_MYT_Infraestructuras_Listado_Modelo_F3 = null;


        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_MYT = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta...........................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(MYT_Infraestructuras).Name), _str_CampoBusqueda, _str_filtro, -1, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                //...................................................................

                if (g_mdl_INTERNO_MYT_Infraestructuras_Listado_Modelo_F3 != null)
                {
                    dnm_MYT = g_mdl_INTERNO_MYT_Infraestructuras_Listado_Modelo_F3;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Infraestructuras_Datos) + "/" + nameof(Obtener_F3), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_MYT;
        }

        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_MYT = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(MYT_Infraestructuras).Name), "", "", _lng_id, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                //....................

                if (g_mdl_INTERNO_MYT_Infraestructuras_Listado_Modelo_F3 != null)
                {
                    dnm_MYT = g_mdl_INTERNO_MYT_Infraestructuras_Listado_Modelo_F3;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Infraestructuras_Datos) + "/" + nameof(Obtener_F3), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_MYT;
        }

        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                string str_SQL =
                   " SELECT distinct " +
                       nameof(INTERNO_MYT_Infraestructuras_Listado_Modelo.id) + " = " + nameof(MYT_Infraestructuras.id) + "," +
                       nameof(INTERNO_MYT_Infraestructuras_Listado_Modelo.codigo) + " = " + nameof(MYT_Infraestructuras.codigo) + "," +
                       nameof(INTERNO_MYT_Infraestructuras_Listado_Modelo.descripcion) + " = " + nameof(MYT_Infraestructuras.descripcion) +
               " FROM " + nameof(MYT_Infraestructuras) +
               " WHERE " + nameof(MYT_Infraestructuras.fechaBorrado) + " IS null AND " +
                       (
                        (_lng_id > -1)
                          ? (nameof(MYT_Infraestructuras.id) + " = " + _lng_id)
                          : (
                               //Filtrar por Codigo
                               (_str_CampoBusqueda.Equals(nameof(MYT_Infraestructuras.codigo)))
                                   ? (nameof(MYT_Infraestructuras.codigo) + "=@Filtro")
                                   //Filtrar por Descripcion
                                   : (nameof(MYT_Infraestructuras.descripcion) + "=@Filtro")
                           )
                       );

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@Filtro",  _str_Filtro)
                };

                //Rellenar el Modelo
                g_mdl_INTERNO_MYT_Infraestructuras_Listado_Modelo_F3 = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_MYT_Infraestructuras_Listado_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Infraestructuras_Datos) + "/" + nameof(ConsultaRellenar_F3), true);
            }
        }
        #endregion

        #region Obtener

        #region Obtener Simple
        private dynamic g_dnm_Modelo_Obtener = null;

        private static int g_int_TotalHilos_Obtener = 1;
        private bool[] g_bol_Hilos_Terminados_Obtener = new bool[g_int_TotalHilos_Obtener];

        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                   " SELECT distinct " +
                       nameof(MYT_Infraestructuras.id) + " = " + nameof(MYT_Infraestructuras.id) + "," +
                       nameof(MYT_Infraestructuras.codigo) + " = " + nameof(MYT_Infraestructuras.codigo) + "," +
                       nameof(MYT_Infraestructuras.descripcion) + " = " + nameof(MYT_Infraestructuras.descripcion) + "," +
                       nameof(MYT_Infraestructuras.fechaBorrado) + " = " + nameof(MYT_Infraestructuras.fechaBorrado) +
               " FROM " + nameof(MYT_Infraestructuras) +
               " WHERE " + nameof(MYT_Infraestructuras.fechaBorrado) + " IS null AND " +
                           nameof(MYT_Infraestructuras.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<MYT_Infraestructuras>(str_SQL, arr_Parametros).FirstOrDefault();

                #region Rellenar tablas Relacionadas
                if (g_dnm_Modelo_Obtener != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Obtener; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Obtener[int_Contador] = false;
                    }

                    //MYT_InfraestructurasSecciones ##########################################################################################
                    ThreadStart obj_ThreadStart_INFRAESTRUCTURASSECCIONES = new ThreadStart(Obtener_InfraestructurasSecciones_Modelo_Obtener);
                    Thread obj_Thread_INFRAESTRUCTURASSECCIONES = new Thread(obj_ThreadStart_INFRAESTRUCTURASSECCIONES);
                    obj_Thread_INFRAESTRUCTURASSECCIONES.Start();

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Obtener)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Infraestructuras_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }
        #region Tablas Relacionadas
        private void Obtener_InfraestructurasSecciones_Modelo_Obtener()
        {
            try
            {
                MYT_InfraestructurasSecciones_Datos obj_MYT_InfraestructurasSecciones_Datos = new MYT_InfraestructurasSecciones_Datos();
                g_dnm_Modelo_Obtener.MYT_InfraestructurasSecciones = obj_MYT_InfraestructurasSecciones_Datos.Obtener_ModeloListado_Por_IdInfraestructura(g_dnm_Modelo_Obtener.id,true);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[0] = true;
            }
        }
        
        #endregion
        #endregion

        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private MYT_Infraestructuras g_mdl_MYT_Infraestructuras = null;
        public MYT_Infraestructuras Obtener_Modelo_Por_Id(long _lng_id,
                                                          bool _bol_Cargar_InfraestructurasSecciones)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                 //WHERE
                                 " WHERE " + nameof(MYT_Infraestructuras) + "." + nameof(MYT_Infraestructuras.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros,
                                         _bol_Cargar_InfraestructurasSecciones);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Infraestructuras_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_MYT_Infraestructuras;
        }

        #region Ejecutar Consulta
        private static int g_int_TotalHilos_Modelo = 1;
        private bool[] g_bol_Hilos_Terminados_Modelo = new bool[g_int_TotalHilos_Modelo];

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                             object[] _arr_Parametros,
                                             bool _bol_Cargar_InfraestructurasSecciones)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_MYT_Infraestructuras = obj_Exferia_Entities.Database.SqlQuery<MYT_Infraestructuras>(_str_SQL, _arr_Parametros).FirstOrDefault();
                
                #region Rellenar Tablas Relacionadas
                if (g_mdl_MYT_Infraestructuras != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Modelo; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Modelo[int_Contador] = false;
                    }

                    //MYT_InfraestructurasSecciones ##########################################################################################
                    if (_bol_Cargar_InfraestructurasSecciones)
                    {
                        ThreadStart obj_ThreadStart_INFRAESTRUCTURASSECCIONES = new ThreadStart(Obtener_InfraestructurasSecciones_Modelo);
                        Thread obj_Thread_INFRAESTRUCTURASSECCIONES = new Thread(obj_ThreadStart_INFRAESTRUCTURASSECCIONES);
                        obj_Thread_INFRAESTRUCTURASSECCIONES.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Modelo[0] = true;
                    }

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Modelo)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Infraestructuras_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #region Tablas Relacionadas
        private void Obtener_InfraestructurasSecciones_Modelo()
        {
            try
            {
                MYT_InfraestructurasSecciones_Datos obj_MYT_InfraestructurasSecciones_Datos = new MYT_InfraestructurasSecciones_Datos();
                g_mdl_MYT_Infraestructuras.MYT_InfraestructurasSecciones = obj_MYT_InfraestructurasSecciones_Datos.Obtener_ModeloListado_Por_IdInfraestructura(g_mdl_MYT_Infraestructuras.id,true);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo[0] = true;
            }
        }
        #endregion
        #endregion
        #endregion

        #region Modelo Listado
        private List<MYT_Infraestructuras> g_lst_MYT_Infraestructuras = null;

        public List<MYT_Infraestructuras> Obtener_ModeloListado_Por_Ids(List<long> _lst_Ids)
        {
            try
            {
                if (_lst_Ids != null && _lst_Ids.Count > 0)
                {

                    string str_Filtro_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(MYT_Infraestructuras),
                                                                                            nameof(MYT_Infraestructuras.id),
                                                                                            G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                            _lst_Ids);

                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                                " WHERE " +
                                                    str_Filtro_IDS;


                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                    new object[] { });

                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Infraestructuras_Datos) + "/" + nameof(Obtener_ModeloListado_Por_Ids), true);
            }

            return g_lst_MYT_Infraestructuras;
        }

        #region Ejecutar Consulta

        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                      object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el modelo
                g_lst_MYT_Infraestructuras = obj_Exferia_Entities.Database.SqlQuery<MYT_Infraestructuras>(_str_SQL, _arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Infraestructuras_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #endregion
        #endregion


        private string Obtener_Consulta_Modelo()
        {
            return
               " SELECT " +
                   nameof(MYT_Infraestructuras.id) + " , " +
                   nameof(MYT_Infraestructuras.codigo) + " , " +
                   nameof(MYT_Infraestructuras.descripcion) + " , " +
                   nameof(MYT_Infraestructuras.fechaBorrado) +
               " FROM " + nameof(MYT_Infraestructuras);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                MYT_Infraestructuras mdl_MYT_Infraestructuras_AGrabar = (MYT_Infraestructuras)_mdl_obj;
                MYT_Infraestructuras mdl_MYT_Infraestructuras_DatosViejos = new MYT_Infraestructuras();

                // Ver si existe ###################################################################### 
                MYT_Infraestructuras mdl_MYT_Infraestructuras_Final = Obtener_Modelo_Por_Id(mdl_MYT_Infraestructuras_AGrabar.id,false);
                //######################################################################################

                //UPDATE
                if (mdl_MYT_Infraestructuras_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_MYT_Infraestructuras_Final, mdl_MYT_Infraestructuras_DatosViejos, false, false);

                    // Cargar los Datos Nuevos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_MYT_Infraestructuras_AGrabar, mdl_MYT_Infraestructuras_Final, false, false);

                    #region update
                    string str_SQL_Update = " UPDATE " + nameof(MYT_Infraestructuras) +
                                           " SET " +
                                               nameof(MYT_Infraestructuras.codigo) + "=@codigo," +
                                               nameof(MYT_Infraestructuras.descripcion) + "=@descripcion," +
                                               nameof(MYT_Infraestructuras.fechaBorrado) + "=@fechaBorrado " +
                                           " WHERE " +
                                               nameof(MYT_Infraestructuras.id) + "=@id";

                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@codigo",  mdl_MYT_Infraestructuras_AGrabar.codigo),
                        new SqlParameter("@descripcion",  mdl_MYT_Infraestructuras_AGrabar.descripcion),
                         mdl_MYT_Infraestructuras_AGrabar.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_MYT_Infraestructuras_AGrabar.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        new SqlParameter("@id",  mdl_MYT_Infraestructuras_AGrabar.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_ValorDevuelto_Modelo.Id = mdl_MYT_Infraestructuras_AGrabar.id;
                }
                //INSERT
                else
                {
                    mdl_MYT_Infraestructuras_Final = new MYT_Infraestructuras();

                    //Tipo de Accion que se va a realizar
                    mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_INSERTAR;

                    // Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_MYT_Infraestructuras_AGrabar, mdl_MYT_Infraestructuras_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(MYT_Infraestructuras) +
                                               " (" +
                                                       nameof(MYT_Infraestructuras.codigo) + "," +
                                                       nameof(MYT_Infraestructuras.descripcion) + "," +
                                                       nameof(MYT_Infraestructuras.fechaBorrado) +
                                               " ) " +
                                               " OUTPUT INSERTED." + nameof(MYT_Infraestructuras.id) +
                                               " VALUES " +
                                               " ( " +
                                                   "@codigo," +
                                                   "@descripcion," +
                                                   "@fechaBorrado" +
                                               " ) ";

                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@codigo",  mdl_MYT_Infraestructuras_AGrabar.codigo),
                        new SqlParameter("@descripcion",  mdl_MYT_Infraestructuras_AGrabar.descripcion),
                        mdl_MYT_Infraestructuras_AGrabar.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_MYT_Infraestructuras_AGrabar.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value)

                    };
                    #endregion

                    //Id de la tabla
                    mdl_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(MYT_Infraestructuras), mdl_MYT_Infraestructuras_DatosViejos, mdl_MYT_Infraestructuras_Final, mdl_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Infraestructuras_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            //Tipo de Accion que se va a realizar
            mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                MYT_Infraestructuras mdl_MYT_Infraestructuras_Final = Obtener_Modelo_Por_Id(_lng_id, false);
                //######################################################################################

                if (mdl_MYT_Infraestructuras_Final != null)
                {
                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(MYT_Infraestructuras) +
                                              " SET " +
                                              nameof(MYT_Infraestructuras.fechaBorrado) + "=@fechaBorrado " +
                                          " WHERE " +
                                              nameof(MYT_Infraestructuras.id) + "=@id";

                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@fechaBorrado",  DateTime.Now),
                        new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                    Datos_Generales.USR_Trazabilidad_Grabar(typeof(MYT_Infraestructuras), null, mdl_MYT_Infraestructuras_Final, Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                }

                //Devolver tambien el Objeto
                mdl_INTERNO_ValorDevuelto_Modelo.Id = _lng_id;
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MYT_Infraestructuras_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }

        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }

        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            throw new NotImplementedException();
        }
        #endregion
    }
}
